#include "init.h"

void
swf_no_gradient()
{
	rb_raise(rb_eRuntimeError, "already closed gradient");
}

static void
swf_free_gradient(p)
	SWFGradient p;
{
	Debug("swf free gradient");
	destroySWFGradient(p);
}

static VALUE
swf_gradient_new(self)
	VALUE self;
{
	VALUE obj;
	
	SWFGradient p;
	p = newSWFGradient();
	obj = Data_Wrap_Struct(self, 0, swf_free_gradient, p);
	return obj;
}

VALUE
swf_gradient_alloc(self, p)
	VALUE self;
	SWFGradient p;
{
	VALUE obj;
	
	obj = Data_Wrap_Struct(self, 0, 0, p);
	return obj;
}

static VALUE
swf_gradient_add_entry(argc, argv, self)
	int argc;
	VALUE* argv;
	VALUE self;
{
	SWFGradient p;
	VALUE ratio, r, g, b, a;
	
	if (rb_scan_args(argc, argv, "41", &ratio, &r, &g, &b, &a) == 4)
		a = INT2FIX(0xff);
	
	GetGradient(self, p);
	SWFGradient_addEntry(p, 
		NUM2DBL(ratio),
		(byte)(NUM2CHR(r)),
		(byte)(NUM2CHR(g)),
		(byte)(NUM2CHR(b)),
		(byte)(NUM2CHR(a)));
	return Qnil;
}

void
swf_init_gradient()
{
	cSwf_gradient = rb_define_class_under(mSwf, "Gradient", rb_cObject);
	rb_define_singleton_method(cSwf_gradient, "new", swf_gradient_new, 0);
	rb_define_method(cSwf_gradient, "add_entry", swf_gradient_add_entry, -1);
}
